#!/bin/sh

# © Jonas Bechtel 2014

false
source version/compatibility.source 2>&1
if [ \! $? = 0 ]; then
	. version/compatibility.source 2>&1
fi


VERSION="`cat version/version.number`"

line=
i=1
rm FILES.tmp 2>/dev/null
touch FILES.tmp

files="`(cat FILES; cat version/self-autobackup-FILES; echo "/")`"
#echo "$files"

while true; do
	
	
	# Manchmal hat sich 'echo' in der folgenden Zeile beschwert:
	line="`echo "$files" | cat | head -n $i | tailx -n 1`"
	# Fehlermeldung:
	# echo: Schreibfehler: Datenübergabe unterbrochen (broken pipe).
	# (Deswegen habe ich ein "| cat"-Glied eingefügt. cat scheint schmerzloser
	#  zu sein.)
	
	#echo $i: "$line"
	#i=$[i+1]
	i=`dcx "$i 1 + p"`
	if [ "`echo "$line" | awk '/^[ \t]*$|^[ \t]*#/ {print "no"}'`" = no ]; then
		continue
	fi
	if [ "$line" = / ]; then
		break
	fi
	
	#find ./$line >>FILES.tmp
	# (we don't need find here as tar recurses into subdirectories by
	#  default.)
	echo ./$line >>FILES.tmp
done

mkdir -p backup
OUTPUT_FILE="backup/`cat version/backup.name`${VERSION}.tar.bz2"
tar -T FILES.tmp -c | bzip2 > "$OUTPUT_FILE"
if [ $? = 0 ]; then
	echo "Created archive in following place: $OUTPUT_FILE"
else
	echo "Error!"
fi

rm FILES.tmp

